/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CorrelationQuery.java,v 1.3 2009-05-05 15:45:27 paules Exp $
 **********************************************************************/

/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy.extensions;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Correlation Query</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.extensions.CorrelationQuery#getCorrelationContainerURI <em>Correlation Container URI</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.extensions.CorrelationQuery#getCorrelationContainerProxyURI <em>Correlation Container Proxy URI</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.extensions.CorrelationQuery#getDeltaTime <em>Delta Time</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getCorrelationQuery()
 * @model
 * @generated
 */
public interface CorrelationQuery extends SimpleSearchQuery {
	/**
	 * Returns the value of the '<em><b>Correlation Container URI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The URI of the correlation container where the correlation entries are stored
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Correlation Container URI</em>' attribute.
	 * @see #setCorrelationContainerURI(String)
	 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getCorrelationQuery_CorrelationContainerURI()
	 * @model
	 * @generated
	 */
	String getCorrelationContainerURI();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.extensions.CorrelationQuery#getCorrelationContainerURI <em>Correlation Container URI</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Correlation Container URI</em>' attribute.
	 * @see #getCorrelationContainerURI()
	 * @generated
	 */
	void setCorrelationContainerURI(String value);

	/**
	 * Returns the value of the '<em><b>Correlation Container Proxy URI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The URI of the correlation container proxy
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Correlation Container Proxy URI</em>' attribute.
	 * @see #setCorrelationContainerProxyURI(String)
	 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getCorrelationQuery_CorrelationContainerProxyURI()
	 * @model
	 * @generated
	 */
	String getCorrelationContainerProxyURI();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.extensions.CorrelationQuery#getCorrelationContainerProxyURI <em>Correlation Container Proxy URI</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Correlation Container Proxy URI</em>' attribute.
	 * @see #getCorrelationContainerProxyURI()
	 * @generated
	 */
	void setCorrelationContainerProxyURI(String value);

	/**
	 * Returns the value of the '<em><b>Delta Time</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Double}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This list contains the delta time for each entry in the Query.sources list.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Delta Time</em>' attribute list.
	 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getCorrelationQuery_DeltaTime()
	 * @model
	 * @generated
	 */
	EList<Double> getDeltaTime();

} // CorrelationQuery
