/**********************************************************************
 * Copyright (c) 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: 
 **********************************************************************/

package org.eclipse.hyades.models.trace;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Obj Alloc Site</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjAllocSite#getMethod <em>Method</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjAllocSite#getClass_ <em>Class</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjAllocSite#getLineNumber <em>Line Number</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjAllocSite#getObjectsCreated <em>Objects Created</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjAllocSite()
 * @model
 * @generated
 */
public interface TRCObjAllocSite extends EObject {

	/**
	 * Returns the value of the '<em><b>Method</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Method</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Method</em>' reference.
	 * @see #setMethod(TRCMethod)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjAllocSite_Method()
	 * @model required="true"
	 * @generated
	 */
	TRCMethod getMethod();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCObjAllocSite#getMethod <em>Method</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Method</em>' reference.
	 * @see #getMethod()
	 * @generated
	 */
	void setMethod(TRCMethod value);

	/**
	 * Returns the value of the '<em><b>Class</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.trace.TRCClass#getAllocationSites <em>Allocation Sites</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Class</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Class</em>' container reference.
	 * @see #setClass(TRCClass)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjAllocSite_Class()
	 * @see org.eclipse.hyades.models.trace.TRCClass#getAllocationSites
	 * @model opposite="allocationSites" required="true" transient="false"
	 * @generated
	 */
	TRCClass getClass_();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCObjAllocSite#getClass_ <em>Class</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Class</em>' container reference.
	 * @see #getClass_()
	 * @generated
	 */
	void setClass(TRCClass value);

	/**
	 * Returns the value of the '<em><b>Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Line Number</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Line Number</em>' attribute.
	 * @see #setLineNumber(int)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjAllocSite_LineNumber()
	 * @model required="true"
	 * @generated
	 */
	int getLineNumber();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCObjAllocSite#getLineNumber <em>Line Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Line Number</em>' attribute.
	 * @see #getLineNumber()
	 * @generated
	 */
	void setLineNumber(int value);

	/**
	 * Returns the value of the '<em><b>Objects Created</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Objects Created</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Objects Created</em>' attribute.
	 * @see #setObjectsCreated(long)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjAllocSite_ObjectsCreated()
	 * @model default="0" required="true"
	 * @generated
	 */
	long getObjectsCreated();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCObjAllocSite#getObjectsCreated <em>Objects Created</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Objects Created</em>' attribute.
	 * @see #getObjectsCreated()
	 * @generated
	 */
	void setObjectsCreated(long value);
} // TRCObjAllocSite
