/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: HyadesFormToolkit.java,v 1.2 2005-05-25 21:49:25 ewchan Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.ui.util;

import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.ui.forms.FormColors;
import org.eclipse.ui.forms.widgets.FormToolkit;

/**
 * @author popescu
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class HyadesFormToolkit extends FormToolkit {

	/**
	 * @param display
	 */
	public HyadesFormToolkit(Display display) {
		super(display);
	}

	/**
	 * @param colors
	 */
	public HyadesFormToolkit(FormColors colors) {
		super(colors);
	}

	/**
	 * @param parent
	 * @param options
	 * @return
	 * @deprecated use createTree 
	 */
	public Composite createTableTree(Composite parent, int options) {
		TableTree table = new TableTree(parent, options);
		adapt(table, false, false);
		//hookDeleteListener(table);
		return table;
	}

	/**
	 * @param comp
	 * @return
	 */
	public ViewForm createViewForm(Composite comp) {
		ViewForm formContent = new ViewForm(comp, SWT.NULL);
		formContent.setBackground(getColors().getBackground());
		formContent.setForeground(getColors().getColor(FormColors.TITLE));
		formContent.setFont(JFaceResources.getHeaderFont());
		return formContent;
	}

	
}
