/**********************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: MoveToMessage.java,v 1.3 2008-01-24 02:28:52 apnan Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.uml2sd.ui.actions;

import java.util.Iterator;

import org.eclipse.hyades.uml2sd.ui.core.BaseMessage;
import org.eclipse.hyades.uml2sd.ui.core.GraphNode;
import org.eclipse.hyades.uml2sd.ui.core.SyncMessage;
import org.eclipse.hyades.uml2sd.ui.core.SyncMessageReturn;
import org.eclipse.hyades.uml2sd.ui.view.SDView;
import org.eclipse.hyades.uml2sd.ui.view.SDWidget;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionProvider;
import org.eclipse.jface.viewers.StructuredSelection;

/**
 * @author sveyrier
 *
 */
public class MoveToMessage extends Action{
	
	protected SDView view = null;
	
	public MoveToMessage(SDView theView)
	{
		super();
		view = theView;
	}
	
	@SuppressWarnings("rawtypes")
	public void run()
	{
/*		if ((view==null)||(view.getSDWidget())==null)
			return;
		else node = view.getSDWidget().getMouseOverNode();	*/
		
		SDWidget sdWidget = view.getSDWidget();
		if (sdWidget==null)
			return;
		ISelectionProvider selProvider = sdWidget.getSelectionProvider();
		ISelection sel=selProvider.getSelection();
		Object selectedNode= null;
		Iterator  it = ((StructuredSelection)sel).iterator();
		while (it.hasNext())
		{
			Object node = it.next();
			if (node instanceof BaseMessage)
				selectedNode = node;
		}	
		if (selectedNode==null)
			return;
			
		if (selectedNode instanceof SyncMessageReturn)
		{
			GraphNode node=((SyncMessageReturn)selectedNode).getMessage();
			sdWidget.clearSelection();
			sdWidget.addSelection(node);
			sdWidget.ensureVisible(node);
//			sdWidget.setFocusNode(node);
			sdWidget.redraw();
		}
		else if (selectedNode instanceof SyncMessage)
		{ 
			GraphNode node=((SyncMessage)selectedNode).getMessageReturn();
			sdWidget.clearSelection();
			sdWidget.addSelection(node);
			sdWidget.ensureVisible(node);
//			sdWidget.setFocusNode(node);
			sdWidget.redraw();
		}			
	}
}
