/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ISVGFeFunc.java,v 1.1 2005-03-30 08:26:38 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.generator;

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ISVGFeFunc.java,v 1.1 2005-03-30 08:26:38 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/



/**
 * <code>ISVGFeFunc</code> interface defines accessors for attributes which are 
 * common to Scalable Vector Graphics (SVG) "feFunc" elements. Also provides for
 * generating the implementation element.
 */
public interface ISVGFeFunc {
    /**
     * Returns the Type.
     * @return String
     */
    public String getType();

    /**
     * Sets the Type.
     * @param type The Type to set
     */
    public void setType(String type);

    /**
     * Returns the intercept.
     * @return String
     */
    public String getIntercept();

    /**
     * Returns the slope.
     * @return String
     */
    public String getSlope();

    /**
     * Sets the intercept.
     * @param intercept The intercept to set
     */
    public void setIntercept(String intercept);

    /**
     * Sets the slope.
     * @param slope The slope to set
     */
    public void setSlope(String slope);
}
