/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DHeader.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.core.internal;


/**
 * DFooter is used to create a page's header in a document.
 * The page header can contain document title, logo, etc...
 * This item is rendering by the <b>Printer driver</b>.
 * DHeader support alignment,all the items added to the header will be displayed 
 * by the driver in the specified alignment.
 * 
 * @see DFooter
 * @see IDAlignment
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class DHeader extends DAbstractParagraph
{
   
   /**
    * Creates a DHeader.
    */
   public DHeader() 
   {
      super();
   }
   
   /**
    * Creates a DHeader with alignment.
    * 
    * @see IDAlignment
    */
   public DHeader(int align) 
   {
   	super(align);
   }
}
