/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DMarkerRegion.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.core.internal;


/**
 * This interface provides the marker region information.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class DMarkerRegion extends DItem {
    
    private String id;
    // fromValue and toValue should be Double or Date
    private Object fromValue;
    private Object toValue;
    private String label;
    private IDColor color;
   
    
    public IDColor getColor() {
        return color;
    }
    public void setColor(IDColor color) {
        this.color = color;
    }
    public String getId() {
        return id;
    }
    public void setId(String id) {
        this.id = id;
    }
    public String getLabel() {
        return label;
    }
    public void setLabel(String label) {
        this.label = label;
    }
   
    public Object getFromValue() {
        return fromValue;
    }
    public void setFromValue(Object fromValue) {
        this.fromValue = fromValue;
    }
    public Object getToValue() {
        return toValue;
    }
    public void setToValue(Object toValue) {
        this.toValue = toValue;
    }
}
