/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IXmlParser.java,v 1.2 2008-05-23 14:12:01 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.drivers.xml.internal;

import java.util.Collection;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;

/**
 * Interface to Xml parsers used by DXmlReader.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IXmlParser
{
  /** Parse the given source, parsed document if any if available through getDocument() */
  public void parse( InputSource source );
  /** @return parsed document, or null if none, or errors occurs */
  public Document getDocument();
  /** @return a list of diagnostic messages after parsing the input source */ 
  public Collection getDiagnostics();  
}
