package org.eclipse.hyades.logging.core;

/**********************************************************************
 * Copyright (c) 2005, 2006 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IExternalizableToXml.java,v 1.2 2006-09-28 17:39:01 cjin Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

/** 
 * Interface for serializing the content of implementing <code>java.lang.Object</code>s
 * to XML fragments .
 *  
 * 
 * @author		Richard Duggan
 * @author		Paul Slauenwhite
 * @version	March 7, 2003
 */
public interface IExternalizableToXml {

    /**
     *	Serializes the content of the implementing <code>java.lang.Object</code> to an XML fragment.
     *
     *	@return The resultant XML fragment of the serialized <code>java.lang.Object</code>.
     */
    public String externalizeCanonicalXmlString();

    /**
     *	Serializes the content of the implementing <code>java.lang.Object</code> to an XML document.
     *
     *	@return The resultant XML document of the serialized <code>java.lang.Object</code>.
     */
    public String externalizeCanonicalXmlDocString();
}
